var timer = null;
var req;
settings = new Array(24);
for(i=0; i<25; i++){
settings[i] = 1;
}
var settingnumber = 0;

if(window.widget) {
	widget.onshow = onShow();
	widget.onhide = onHide();
}

function onShow(event){
	if(event != "null"){
		loadSetting(readyStateChange);
	}
	else document.getElementById("debug").innerHTML = "(´･ω･｀)ﾏﾀﾞﾘﾝｼﾞﾀﾞﾖ";
	drawClock();
}

function onHide(){
	stopTimer();
	clearCanvas();
}

function startTimer(){
	timer = setInterval("checkTime();", 1000);
}

function stopTimer(){
	clearClock();
	if(timer != null){
		clearInterval(timer);
		timer = null;
	}
}

function checkTime() {
	if(timer != null){
		myD = new Date();
		myseconds = myD.getSeconds();
		if (myseconds == "00") {
			drawClock();
		}
	}
}
////////////////////////////////////////////////////////////////Statement
function loadSetting(event) {
	req = new XMLHttpRequest();
	req.onreadystatechange = event;
	req.overrideMimeType("text/xml");
	req.open("GET", "./setting.xml",false);
	req.send(null);
}
function readyStateChange(){
	if (req.readyState == 4) {
		if (req.responseXML){
			var settingnumber = document.getElementById("setting").value;
			var xmldata = req.responseXML.getElementsByTagName("item");

			settings[0] = xmldata[settingnumber].getElementsByTagName("hourbeforered")[0].firstChild.nodeValue;
			settings[1] = xmldata[settingnumber].getElementsByTagName("hourbeforegreen")[0].firstChild.nodeValue;
			settings[2] = xmldata[settingnumber].getElementsByTagName("hourbeforeblue")[0].firstChild.nodeValue;
			settings[3] = xmldata[settingnumber].getElementsByTagName("hourbeforetransparency")[0].firstChild.nodeValue;
			
			settings[4] = xmldata[settingnumber].getElementsByTagName("houraftered")[0].firstChild.nodeValue;
			settings[5] = xmldata[settingnumber].getElementsByTagName("houraftergreen")[0].firstChild.nodeValue;
			settings[6] = xmldata[settingnumber].getElementsByTagName("hourafterblue")[0].firstChild.nodeValue;
			settings[7] = xmldata[settingnumber].getElementsByTagName("houraftertransparency")[0].firstChild.nodeValue;
			
			settings[8] = xmldata[settingnumber].getElementsByTagName("minutebeforered")[0].firstChild.nodeValue;
			settings[9] = xmldata[settingnumber].getElementsByTagName("minutebeforegreen")[0].firstChild.nodeValue;
			settings[10] = xmldata[settingnumber].getElementsByTagName("minutebeforeblue")[0].firstChild.nodeValue;
			settings[11] = xmldata[settingnumber].getElementsByTagName("minutebeforetransparency")[0].firstChild.nodeValue;
			
			settings[12] = xmldata[settingnumber].getElementsByTagName("minuteaftered")[0].firstChild.nodeValue;
			settings[13] = xmldata[settingnumber].getElementsByTagName("minuteaftergreen")[0].firstChild.nodeValue;
			settings[14] = xmldata[settingnumber].getElementsByTagName("minuteafterblue")[0].firstChild.nodeValue;
			settings[15] = xmldata[settingnumber].getElementsByTagName("minuteaftertransparency")[0].firstChild.nodeValue;
			
			settings[16] = xmldata[settingnumber].getElementsByTagName("gradation")[0].firstChild.nodeValue;
			
			settings[17] = xmldata[settingnumber].getElementsByTagName("hourhandwidth")[0].firstChild.nodeValue;
			settings[18] = xmldata[settingnumber].getElementsByTagName("hourradius")[0].firstChild.nodeValue;
			settings[19] = xmldata[settingnumber].getElementsByTagName("minutehandwidth")[0].firstChild.nodeValue;
			settings[20] = xmldata[settingnumber].getElementsByTagName("minuteradius")[0].firstChild.nodeValue;
			
			settings[21] = xmldata[settingnumber].getElementsByTagName("hourhandguideheight")[0].firstChild.nodeValue;
			settings[22] = xmldata[settingnumber].getElementsByTagName("hourhandguideradius")[0].firstChild.nodeValue;
			settings[23] = xmldata[settingnumber].getElementsByTagName("minutehandguideheight")[0].firstChild.nodeValue;
			settings[24] = xmldata[settingnumber].getElementsByTagName("minutehandguideradius")[0].firstChild.nodeValue;
		}
	}
	drawClock();
}

function readyLoadSettingName(){
	if (req.readyState == 4) {
		if (req.responseXML){
			var xmldata = req.responseXML.getElementsByTagName("name");
			var titlelength = xmldata.length;
			for (i=0; i<titlelength; i++){
				document.getElementById("setting").innerHTML += "<option value=" + i + ">" + xmldata[i].firstChild.nodeValue + "</option>";
			}
		}
	}
}
////////////////////////////////////////////////////////////////Statement

function drawClock() {
	myD = new Date();
	myyear = myD.getYear();
	myyear4 = (myyear < 2000) ? myyear+1900 : myyear;
	mymonth = myD.getMonth() + 1;
	mydate = myD.getDate();
	myday = myD.getDay();
	myhours = myD.getHours();
	myminutes = myD.getMinutes();
	myseconds = myD.getSeconds();
	myTbl = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
	var canvas = document.getElementById("mainCanvas");
	var context = canvas.getContext("2d");
	var myhourspi = Math.PI*myhours/6+Math.PI*myminutes/360;
	var myminutespi = Math.PI/180*myminutes*6;
	context.clearRect(0,0,300,300);
	context.save();
//		document.getElementById("debug").innerText = "（・∀・）" + settings[14] + "ﾀﾞﾖ!!";
	for(i=0; i<settings[16]; i++){
		context.arc(150,150,settings[18],2*Math.PI*i/settings[16]-Math.PI/2+myhourspi,2*Math.PI*(i+3)/settings[16]-Math.PI/2+myhourspi,0);
		context.lineWidth = settings[17];
		context.setStrokeColor((settings[4]-settings[0])*i/settings[16]+settings[0],(settings[5]-settings[1])*i/settings[16]+settings[1],(settings[6]-settings[2])*i/settings[16]+settings[2],(settings[7]-settings[3])*i/settings[16]+settings[3]);
		context.stroke();
	}
	context.restore();
	context.save();
	for(i=0; i<settings[16]; i++){
		context.arc(150,150,settings[20],2*Math.PI*i/settings[16]-Math.PI/2+myminutespi,2*Math.PI*(i+3)/settings[16]-Math.PI/2+myminutespi,0);
		context.lineWidth = settings[19];
		context.setStrokeColor((settings[12]-settings[8])*i/settings[16]+settings[8],(settings[13]-settings[9])*i/settings[16]+settings[9],(settings[14]-settings[10])*i/settings[16]+settings[10],(settings[15]-settings[11])*i/settings[16]+settings[11]);
		context.stroke();
	}
	context.restore();
	
	var hourguide = 12
	context.save();
	for(var i= 0; i < hourguide; i++){
		context.save();
		context.translate(150,150);
		context.rotate(i*(2*Math.PI/hourguide));
		context.beginPath();
		context.moveTo(settings[22],0);
		context.lineTo(settings[22]-settings[21],0);
		context.lineWidth = 1;
		context.strokeStyle = "rgba(255,255,255,1)";
		context.closePath();
		context.stroke();
		context.restore();
	}
	context.restore();
	context.save();
	var minguide =60
	for(var i= 0; i < minguide; i++){
		context.save();
		context.translate(150,150);
		context.rotate(i*(2*Math.PI/minguide));
		context.beginPath();
		context.moveTo(settings[24],0);
		context.lineTo(settings[24]-settings[23],0);
		context.lineWidth = 0.5;
		context.strokeStyle = "rgba(255,255,255,1)";
		context.closePath();
		context.stroke();
		context.restore();
	}
	context.restore();
//	document.getElementById("timeStrings").innerHTML = mymonth+"/"+mydate+" ("+myTbl[myday]+") "+myhours+":"+myminutes;
	clearInterval(timer);
}